package net.ihe.gazelle.httpvalidator.interlay.service;

import net.ihe.gazelle.framework.modelvalidator.domain.ValidatorBuilderFactory;
import net.ihe.gazelle.httpvalidator.application.service.HttpEngineValidationService;
import net.ihe.gazelle.httpvalidator.application.service.ValidationProfileService;
import net.ihe.gazelle.httpvalidator.application.service.WellFormedValidationService;
import net.ihe.gazelle.httpvalidatorengine.domain.validationprofile.ValidationProfile;
import net.ihe.gazelle.servicemetadata.api.application.MetadataService;
import net.ihe.gazelle.servicemetadata.api.domain.structure.Service;
import net.ihe.gazelle.validation.api.application.ValidationService;
import net.ihe.gazelle.validation.api.domain.metadata.structure.ValidationInterface;
import net.ihe.gazelle.validation.api.domain.report.structure.AssertionReportBuilder;
import net.ihe.gazelle.validation.api.domain.report.structure.ValidationReportBuilder;
import net.ihe.gazelle.validation.api.domain.report.structure.ValidationSubReportBuilder;
import net.ihe.gazelle.validation.api.domain.report.structure.*;
import net.ihe.gazelle.validation.api.domain.request.structure.ValidationRequest;

import java.util.List;

public class HttpValidationServiceImpl implements ValidationService {

    private final ValidationProfileService validationProfileService;
    private final WellFormedValidationService wellFormedValidationService;
    private final HttpEngineValidationService httpEngineValidationService;
    private final MetadataService metadataService;
    private final ValidatorBuilderFactory validatorBuilderFactory;

    public HttpValidationServiceImpl(ValidationProfileService validationProfileService,
                                     WellFormedValidationService wellFormedValidationService,
                                     HttpEngineValidationService httpEngineValidationService,
                                     MetadataService metadataService,
                                     ValidatorBuilderFactory validatorBuilderFactory) {
        this.validationProfileService = validationProfileService;
        this.wellFormedValidationService = wellFormedValidationService;
        this.httpEngineValidationService = httpEngineValidationService;
        this.metadataService = metadataService;
        this.validatorBuilderFactory = validatorBuilderFactory;
    }

    @Override
    public ValidationReport validate(ValidationRequest validationRequest) {
        byte[] content = validationRequest.getValidationItems().get(0).getContent();
        ValidationProfile validationProfile = validationProfileService.getAvailableProfile(validationRequest.getValidationProfileId());
        ValidationSubReport wellFormedReport = wellFormedValidationService.validate(content, validationProfile.getProfileType());
        ValidationSubReport httpValidationReport;
        if (wellFormedValidationService.isWellFormed()) {
            httpValidationReport = httpEngineValidationService.validate(content, validationProfile);
        } else {
            httpValidationReport = buildFailedSubReport(validationProfile);
        }

        return buildValidationReport(validationProfile, wellFormedReport, httpValidationReport);
    }

    @Override
    public List<net.ihe.gazelle.validation.api.domain.metadata.structure.ValidationProfile> getValidationProfiles() {
        return metadataService.getMetadata()
                .getProvidedInterfaces()
                .stream()
                .filter(ValidationInterface.class::isInstance)
                .map(validationInterface -> ((ValidationInterface) validationInterface).getValidationProfiles())
                .flatMap(List::stream)
                .toList();
    }

    private ValidationSubReport buildFailedSubReport(ValidationProfile validationProfile) {
        return new ValidationSubReport()
                .setName(validationProfile.getName())
                .setStandards(new String[]{"HTTP"})
                .addAssertionReport(new AssertionReport()
                        .setAssertionID("Not Well Formed Validation")
                        .setDescription("The validation couldn't be performed because the HTTP Message is not well formed")
                        .setResult(ValidationTestResult.FAILED)
                        .setPriority(RequirementPriority.MANDATORY));
    }

    private ValidationReport buildValidationReport(ValidationProfile validationProfile,
                                                   ValidationSubReport wellFormedReport,
                                                   ValidationSubReport httpValidationReport) {
        Service service = metadataService.getMetadata();
        return new ValidationReportBuilder(validatorBuilderFactory)
                .setDisclaimer("This report is generated by HTTP Validator Web Service")
                .setValidationMethod(new ValidationMethod()
                        .setValidationProfileID(validationProfile.getId())
                        .setValidationServiceName(service.getName())
                        .setValidationServiceVersion(service.getVersion())
                        .setValidationProfileVersion("1.0")
                )
                .addSubReport(getSubReportBuilder(wellFormedReport))
                .addSubReport(getSubReportBuilder(httpValidationReport))
                .build();

    }

    private ValidationSubReportBuilder getSubReportBuilder(ValidationSubReport validationSubReport) {
        return new ValidationSubReportBuilder(validatorBuilderFactory)
                .setName(validationSubReport.getName())
                .setStandards(validationSubReport.getStandards())
                .setAssertionReports(validationSubReport.getAssertionReports().stream()
                        .map(assertionReport -> new AssertionReportBuilder(validatorBuilderFactory)
                                .setAssertionID(assertionReport.getAssertionID())
                                .setDescription(assertionReport.getDescription())
                                .setAssertionType(assertionReport.getAssertionType())
                                .setPriority(assertionReport.getPriority())
                                .setResult(assertionReport.getResult())
                                .setRequirementIDs(assertionReport.getRequirementIDs())
                                .setSubjectLocation(assertionReport.getSubjectLocation())
                                .setSubjectValue(assertionReport.getSubjectValue())
                        )
                        .toList()
                );
    }
}
